package cn.iocoder.yudao.module.system.dal.mysql.laborcontract;

import cn.iocoder.yudao.framework.mybatis.core.mapper.BaseMapperX;
import cn.iocoder.yudao.framework.mybatis.core.query.LambdaQueryWrapperX;
import cn.iocoder.yudao.framework.tenant.core.aop.TenantIgnore;
import cn.iocoder.yudao.module.system.controller.admin.file.vo.FileRespVO;
import cn.iocoder.yudao.module.system.controller.admin.laborcontract.vo.LaborContractRespVO;
import cn.iocoder.yudao.module.system.dal.dataobject.laborcontract.LaborContractDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;

import java.time.LocalDate;
import java.util.List;

/**
 * 劳动合同管理 Mapper
 *
 * @author 符溶馨
 */
@Mapper
public interface LaborContractMapper extends BaseMapperX<LaborContractDO> {

    default List<LaborContractDO> selectHistoryList(Long userId) {

        return selectList(new LambdaQueryWrapperX<LaborContractDO>()
                .eqIfPresent(LaborContractDO::getUserId, userId)
                .orderByDesc(LaborContractDO::getCreateTime));
    }

    @TenantIgnore
    List<FileRespVO> selectFileByUserId(@Param("mobile") String mobile);

    /**
     * 获取用户最早合同
     *
     * @param userId
     * @return
     */
    LaborContractDO getTheEarliestContract(@Param("userId") Long userId);

    List<LaborContractDO> selectListByRemindDate(@Param("remindDate")LocalDate remindDate);

    List<LaborContractRespVO> selectContractCount(@Param("userIds") List<Long> userIds);
}
